unit EsimageFM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TESimageFM = class(TGraphicControl)
private
 Dest1              : TRect;
 Dest2              : TRect;
 EAutosize          : Boolean;
 ECaption           : Tcaption;
 ECenter            : Boolean;
 EColor             : TColor;
 EFont              : TFont;
 EHotRectangle      : Boolean;
 EHotText           : Boolean;
 EHotColor          : TColor;
 EPicture1          : TPicture;
 EPicture2          : TPicture;
 EShowCaption       : Boolean;
 ETransparent       : Boolean;
 Mousein            : Boolean;
 Procedure PictureChanged(Sender:TObject);
 procedure SetAutosize(Value: Boolean);
 procedure SetCaption(Value:TCaption);
 procedure SetCenter(Value: Boolean);
 procedure SetColor(Value:TColor);
 procedure SetFont(Value:TFont);
 procedure SetHotColor(Value:TColor);
 procedure SetHotRectangle(Value:Boolean);
 procedure SetHotText(Value:Boolean);
 procedure SetPicture1(Value:TPicture);
 procedure SetPicture2(Value:TPicture);
 procedure SetShowCaption(Value: Boolean);
 procedure SetTransparent(Value: Boolean);
 procedure CMMouseEnter(var AMsg: TMessage); message CM_MOUSEENTER;
 procedure CMMouseLeave(var AMsg: TMessage); message CM_MOUSELEAVE;
protected
 procedure Paint; override;
public
 constructor Create(COwner: TComponent); override;
 destructor Destroy; override;
published
 Property Align;
 property Anchors;
 property Autosize: Boolean read EAutosize write SetAutosize;
 property Caption: TCaption read Ecaption write SetCaption;
 property Center: Boolean read ECenter write SetCenter;
 property Cursor;
 property Color: TColor read EColor write SetColor;
 property Constraints;
 property Enabled;
 property Font:TFont read EFont write SetFont;
 property HotColor: TColor read EHotColor write SetHotColor;
 property HotRectangle: Boolean read EHotRectangle write SetHotRectangle;
 property HotText: Boolean read EHotText write SetHotText;
 property Picture1: TPicture read EPicture1 write SetPicture1;
 property Picture2: TPicture read EPicture2 write SetPicture2;
 property Popupmenu;
 property ShowCaption: Boolean read EShowCaption write SetShowCaption;
 property ShowHint;
 property Transparent: Boolean read ETransparent write SetTransparent;
 property Visible;
 property OnClick;
 property OnDblClick;
 property OnDragDrop;
 property OnDragOver;
 property OnEndDrag;
 property OnMouseDown;
 property OnMouseMove;
 property OnMouseUp;
 property OnStartDrag;
end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Additional', [TESImageFM]);
end;

constructor TESimageFM.Create(COwner: TComponent);
begin
  inherited Create(COwner);
  ControlStyle := ControlStyle + [csReplicatable];
  ControlStyle := ControlStyle - [csOpaque];
  EPicture1 := TPicture.Create;
  EPicture2 := TPicture.Create;
  EPicture1.OnChange := PictureChanged;
  EFont:= TFont.Create;
  EHotColor:=clblue;
  EColor:=clblack;
  if Height<1 then Height := 60;
  if Width<1 then Width  := 60;
  picturechanged(self);
end;

destructor TESimageFM.Destroy;
begin
  EPicture1.Free;
  EPicture2.Free;
  inherited Destroy;
end;

procedure TESimageFM.SetAutosize(Value: Boolean);
begin
  if EAutosize <> Value then
  begin
    EAutosize := Value;
    PictureChanged(Self);
  end;
end;

procedure TESimageFM.SetCaption(Value: TCaption);
begin
 if ECaption<>value then
  begin
   ECaption:=value;
   PictureChanged(Self);
  end;
end;

procedure TESimageFM.SetCenter(Value: Boolean);
begin
  if ECenter <> Value then
  begin
    ECenter := Value;
    PictureChanged(Self);
  end;
end;

procedure TESimageFM.SetColor(Value: TColor);
begin
 if EColor<>value then
  begin
   EColor:=value;
   PictureChanged(Self);
  end;
end;

procedure TESimageFM.SetFont(Value: TFont);
begin
 if EFont<>value then
  begin
   EFont.assign(value);
   Canvas.Font.assign(value);
   PictureChanged(Self);
  end;
end;

procedure TESimageFM.SetHotColor(Value: TColor);
begin
 if EHotColor<>value then
  begin
   EHotColor:=value;
  end;
end;

procedure TESimageFM.SetHotRectangle(Value: Boolean);
begin
 if EHotRectangle<>value then
  begin
   EHotRectangle:=value;
  end;
end;

procedure TESimageFM.SetHotText(Value: Boolean);
begin
 if EHotText<>value then
  begin
   EHotText:=value;
  end;
end;

procedure TESimageFM.SetPicture1(Value: TPicture);
begin
  EPicture1.Assign(Value);
  PictureChanged(Self);
end;

procedure TESimageFM.SetPicture2(Value: TPicture);
begin
  EPicture2.Assign(Value);
  PictureChanged(Self);
end;

procedure TESimageFM.SetShowCaption(Value: Boolean);
begin
  if Value <> EShowCaption then
   begin
   EShowCaption:=value;
   PictureChanged(Self);
   end;
end;

procedure TESimageFM.SetTransparent(Value: Boolean);
begin
  if Value <> ETransparent then
   begin
   ETransparent:=value;
   PictureChanged(Self);
   end;
end;

procedure TESimageFM.Paint;
var txtwidth:word;
begin
 Dest1:= Bounds((Width - Picture1.Width) div 2, 0,
      Picture1.Width, Picture1.Height);
 Dest2 := Bounds((Width - Picture2.Width) div 2, 0,
      Picture2.Width, Picture2.Height);
 canvas.font.assign(font);
 canvas.Brush.Color:=color;
 canvas.pen.Color:=color;
 canvas.Rectangle(0,0,width,height);
 if mousein=false then begin
  with inherited Canvas do
  begin
   setbkmode(handle,1);
   if picture1.Graphic<>nil then
     StretchDraw(dest1,Picture1.Graphic);
   txtwidth:=textwidth(caption);
   if showcaption then
     textout((width-txtwidth) div 2,height-textheight(caption),Caption);
  end;
end else begin
  if hottext then canvas.font.color:=hotcolor;
  canvas.brush.color:=hotcolor;
  with inherited Canvas do
  begin
   setbkmode(handle,1);
   if picture2.Graphic<>nil then
    StretchDraw(dest2, Picture2.Graphic)
   else
    if picture1.Graphic<>nil then
     StretchDraw(dest1, Picture1.Graphic);
   txtwidth:=textwidth(caption);
   if showcaption then
     textout((width-txtwidth) div 2,height-textheight(caption),Caption);
   if hotrectangle then framerect(rect(0,0,width,height));
  end;
end;
  if csDesigning in ComponentState then
  drawfocusrect(canvas.handle,rect(0,0,width,height));
end;

procedure TESimageFM.PictureChanged(Sender: TObject);
var w,h:word;
begin
 if autosize then begin
  if picture1.Width>picture2.Width then
   w:=picture1.Width else w:=picture2.Width;
  if picture1.Height>picture2.Height then
   h:=picture1.Height else h:=picture2.Height;
  if showcaption then begin
   h:=h-font.height+2;
   if canvas.TextWidth(caption)>w then w:=canvas.TextWidth(caption);
  end;
 end else begin
  h:=height;
  w:=width;
 end;
 if h<5 then h:=5;
 if w<5 then w:=5;
 setbounds(left,top,w,h);
 if picture1.Graphic<>nil then
  picture1.Graphic.Transparent:=Etransparent;
 if picture2.Graphic<>nil then
  picture2.Graphic.Transparent:=Etransparent;
Invalidate;
end;

procedure TESimageFM.CMMouseEnter(var AMsg: TMessage);
begin
 MouseIn:=True;
 Refresh;
end;

procedure TESimageFM.CMMouseLeave(var AMsg: TMessage);
begin
 MouseIn:=False;
 Refresh;
end;

end.
